Set bit

- « gmp_scan1

- gmp_sign »

- PHP Manual
- GMP Functions
- Set bit

# gmp_setbit

(PHP 4 >= 4.0.4, PHP 5, PHP 7, PHP 8)

gmp_setbit — Set bit

### Description

gmp_setbit(GMP `$num`, int `$index`, bool `$value` = `true`): void

Sets bit `index` in `num`.

### Parameters

`num`

  A GMP object.

`index`

  The index of the bit to set. Index 0 represents the least significant bit.

`value`

  True to set the bit (set it to 1/on); false to clear the bit (set it to 0/off).

### Return Values

A GMP object.

### Examples

Example #1 gmp_setbit() example - 0 index

    <?php$a = gmp_init("2"); //echo gmp_strval($a), ' -> 0b', gmp_strval($a, 2), "\n";gmp_setbit($a, 0); // 0b10 now becomes 0b11echo gmp_strval($a), ' -> 0b', gmp_strval($a, 2), "\n";?>

The above example will output:

    2 -> 0b10
    3 -> 0b11

Example #2 gmp_setbit() example - 1 index

    <?php$a = gmp_init("0xfd");echo gmp_strval($a), ' -> 0b', gmp_strval($a, 2), "\n";gmp_setbit($a, 1); // index starts at 0echo gmp_strval($a), ' -> 0b', gmp_strval($a, 2), "\n";?>

The above example will output:

    253 -> 0b11111101
    255 -> 0b11111111

Example #3 gmp_setbit() example - clearing a bit

    <?php$a = gmp_init("0xff");echo gmp_strval($a), ' -> 0b', gmp_strval($a, 2), "\n";gmp_setbit($a, 0, false); // clear bit at index 0echo gmp_strval($a), ' -> 0b', gmp_strval($a, 2), "\n";?>

The above example will output:

    255 -> 0b11111111
    254 -> 0b11111110

### Notes

> Note:

> Unlike most of the other GMP functions, gmp_setbit() must be called with a GMP object that already exists (using gmp_init() for example). One will not be automatically created.

### See Also

- gmp_clrbit() - Clear bit
- gmp_testbit() - Tests if a bit is set